######################### SETTINGS #################################
# Set left mouse button active
active_buttons = 1;
button_codes = 1; 

# Enable logging of responses.
response_logging = log_active; 

# Set correct answer property
stimulus_properties = correct, number;
event_code_delimiter = ";";


# Set default font to Arial to match instructions font.
default_font = "Arial";
# Set font size
default_font_size = 48;

begin;

#################### STIMULUS INITIALIZATION #######################
# Initialize stimulus array
array {
   text { caption = "platery"; description = "0"; } A;
   text { caption = "denial"; description = "1"; } ;
   text { caption = "generic"; description = "1"; } ;
   text { caption = "mensible"; description = "0"; } ;
   text { caption = "scornful"; description = "1"; } ;
   text { caption = "stoutly"; description = "1"; } ;
   text { caption = "ablaze"; description = "1"; } ;
   text { caption = "kermshaw"; description = "0"; } ;
   text { caption = "moonlit"; description = "1"; } ;
   text { caption = "lofty"; description = "1"; } ;
   text { caption = "hurricane"; description = "1"; } ;
   text { caption = "flaw"; description = "1"; } ;
   text { caption = "alberation"; description = "0"; } ;
   text { caption = "unkempt"; description = "1"; } ;
   text { caption = "breeding"; description = "1"; } ;
   text { caption = "festivity"; description = "1"; } ;
   text { caption = "screech"; description = "1"; } ;
   text { caption = "savoury"; description = "1"; } ;
   text { caption = "plaudate"; description = "0"; } ;
   text { caption = "shin"; description = "1"; } ;
   text { caption = "fluid"; description = "1"; } ;
   text { caption = "spaunch"; description = "0"; } ;
   text { caption = "allied"; description = "1"; } ;
   text { caption = "slain"; description = "1"; } ;
   text { caption = "recipient"; description = "1"; } ;
   text { caption = "exprate"; description = "0"; } ;
   text { caption = "eloquence"; description = "1"; } ;
   text { caption = "cleanliness"; description = "1"; } ;
   text { caption = "dispatch"; description = "1"; } ;
   text { caption = "rebondicate"; description = "0"; } ;
   text { caption = "ingenious"; description = "1"; } ;
   text { caption = "bewitch"; description = "1"; } ;
   text { caption = "skave"; description = "0"; } ;
   text { caption = "plaintively"; description = "1"; } ;
   text { caption = "kilp"; description = "0"; } ;
   text { caption = "interfate"; description = "0"; } ;
   text { caption = "hasty"; description = "1"; } ;
   text { caption = "lengthy"; description = "1"; } ;
   text { caption = "fray"; description = "1"; } ;
   text { caption = "crumper"; description = "0"; } ;
   text { caption = "upkeep"; description = "1"; } ;
   text { caption = "majestic"; description = "1"; } ;
   text { caption = "magrity"; description = "0"; } ;
   text { caption = "nourishment"; description = "1"; } ;
   text { caption = "abergy"; description = "0"; } ;
   text { caption = "proom"; description = "0"; } ;
   text { caption = "turmoil"; description = "1"; } ;
   text { caption = "carbohydrate"; description = "1"; } ;
   text { caption = "scholar"; description = "1"; } ;
   text { caption = "turtle"; description = "1"; } ;
   text { caption = "fellick"; description = "0"; } ;
   text { caption = "destription"; description = "0"; } ;
   text { caption = "cylinder"; description = "1"; } ;
   text { caption = "censorship"; description = "1"; } ;
   text { caption = "celestial"; description = "1"; } ;
   text { caption = "rascal"; description = "1"; } ;
   text { caption = "purrage"; description = "0"; } ;
   text { caption = "pulsh"; description = "0"; } ;
   text { caption = "muddy"; description = "1"; } ;
   text { caption = "quirty"; description = "0"; } ;
   text { caption = "pudour"; description = "0"; } ;
   text { caption = "listless"; description = "1"; } ;
   text { caption = "wrought"; description = "1"; } ;
} words;

# Initialize instruction slide
picture { bitmap { filename = "englishInstructions.bmp"; preload = true; }instbmp; 
x=0; y=0;
}instructionsbmp;

picture {text {caption = " "; font_size = 50;}t_result; x=0; y=0;
}p_result;

picture {arrow_graphic {coordinates = 7, -7, -7, 7; 
								line_width = 2;
								color = 255, 255, 255;
								head_width = 10;
								head_length = 10;
							  }arrow1; x = 0; y = 0;
							  
			text {caption = " "; font_size = 50;}t_trial; x=0; y=100;

			box { color = 255,0,0; height = 100; width = 200; } box1; x=-150; y=-100;   
			box { color = 0,255,0; height = 100; width = 200; } box2; x= 150; y=-100;   
			text { caption = "no"; font_size = 36; background_color = 255,0,0 ; font_color = 0,0,0;} no; x=-150; y=-100;   
			text { caption = "yes"; font_size = 36; background_color = 0,255,0 ; font_color = 0,0,0;} yes; x=150; y=-100;   

}p_trial;

##################### TRIAL INITIALIZATION ####################################
# Instruction trial
trial {
   trial_duration = forever;
   trial_type = first_response;
   picture instructionsbmp;
	code = "instructiontrial";
   time = 0;
   duration = response;
 } instruction_trial;


#################### PCL PART STARTS HERE #####################################
begin_pcl;

#-----------------------------Definne used variables------------------------------------
array <int> aiResultWord[words.count()];			# define result arrays
array <int> aiResultNonWord[words.count()];		

int count_old;

mouse mse = response_manager.get_mouse( 1 );

int iMouseX;
int iMouseY;

int iObjectCount = 9;
array <string> asMST [iObjectCount] [4];

int iMouseInObject = 0;

string templog;
output_file ofile1 = new output_file;

#-----------------------------WaitForAllButtonpress------------------------------------
sub WaitForAllButtonpress begin
 
   loop 
	count_old = response_manager.total_response_count();	
	
	until (response_manager.total_response_count() > count_old) 
   begin end;
end;

#-----------------------------CreateMouseSensitiveText-------------------
sub CreateMouseSensitiveArea (int objectno, int left_x, int right_x, int lower_y, int upper_y) 
begin

	asMST[objectno][1] = string (left_x);
	asMST[objectno][2] = string (right_x);
	asMST[objectno][3] = string (lower_y);
	asMST[objectno][4] = string (upper_y);
	
end;

#-----------------------------InitMouseAreas -------------------
sub InitMouseAreas 
begin
	CreateMouseSensitiveArea (1, -250, -50, -150, -50);						# create rectangle sensitive area
	CreateMouseSensitiveArea (2, 50, 250, -150, -50);

	p_trial.set_part_on_top (1, true);											# the arrow has to be on top


end;

#-----------------------------IsMouseInObject-------------------
sub IsMouseInObject
begin
	loop int ii = 1 until ii > iObjectCount
	begin
		if ((iMouseX > int (asMST[ii][1])) && (iMouseX < int (asMST[ii][2])) && 
			(iMouseY > int (asMST[ii][3])) && (iMouseY < int (asMST[ii][4])))
		then 
			iMouseInObject = ii;
			break;
		else
			iMouseInObject = 0;
		end;
		
		ii = ii + 1;
	end;

end;

#-----------------------------MouseGetOnlyPosition-------------------
sub MouseGetOnlyPosition 
begin
		mse.poll();
		iMouseX = mse.pos( 1 );
		iMouseY = mse.pos( 2 );
end;


#-----------------------------WaitforMouseclick-------------------
sub WaitforMouseclick
begin	
	loop count_old = response_manager.total_response_count();	
		until ((response_manager.total_response_count() > count_old) && (iMouseInObject != 0))
	begin
		MouseGetOnlyPosition();
		p_trial.set_part_x(1, iMouseX);
		p_trial.set_part_y(1, iMouseY);
		IsMouseInObject();
		
		if (iMouseInObject == 1)
		then
			box1.set_color (128,0,0);
			no.set_background_color (128,0,0);
			box2.set_color (0,255,0);
			yes.set_background_color(0,255,0);
		elseif (iMouseInObject == 2)
		then
			box1.set_color (255,0,0);
			no.set_background_color (255,0,0);
			box2.set_color (0,128,0);
			yes.set_background_color(0,128,0);
		else
			box1.set_color (255,0,0);
			no.set_background_color (255,0,0);
			box2.set_color (0,255,0);
			yes.set_background_color(0,255,0);
		end;
		
		no.redraw();
		yes.redraw();
		p_trial.present();
	end;
end;

#-----------------------------CreateOutput------------------------------------
sub CreateOutput(string str ) begin

	templog = "";

   templog.append("Scenario - EnglishLexTALE\n");
   templog.append("Logfile written - " + date_time() + "\n");
   templog.append("Subject: " + logfile.subject() + "\n\n");
  
   ofile1 = new output_file;
   ofile1.open( str, true ); # don't overwrite

   ofile1.print( templog );
   ofile1.close();

end; 

############################## Begin of the experiment #################################

CreateOutput(logfile.subject() + "_" + "score.txt");				# create Header of the output file

loop int k=1 until k>words.count()								# initialize result arrays with zeroes
begin
	aiResultWord[k] = 0;
	aiResultNonWord[k] = 0;
	k=k+1;
end;

InitMouseAreas();														# deine the mouse senisive areas

instruction_trial.present();										# Present instruction trial

loop int i = 1 until i > words.count() 						# Loop through stimulus trials
begin

   t_trial.set_caption(words[i].caption());
   t_trial.redraw();
   p_trial.present();
   
   WaitforMouseclick();
   
   if (int(words[i].description()) == 1)						# is it a word ?
   then
		if (iMouseInObject == 2)									# was the response "yes"?
		then
			aiResultWord[i] = 1;
		end;
	else
		if (iMouseInObject == 1)									# was the response "no"?
		then
			aiResultNonWord[i] = 1;
		end;		
	end;
	
   i = i + 1
end;

int iResultWord = 0;												# define result variables
int iResultNonWord = 0;
int iResult;
	
loop int k=4 until k>words.count()							# count the correct responses and ignore the first 3 trials (they are dummy trials)
begin
	iResultWord = iResultWord + aiResultWord[k];
	iResultNonWord = iResultNonWord + aiResultNonWord[k];
	k=k+1;
end;

iResult = (((100*iResultWord)/40) + ((100*iResultNonWord)/20)) / 2;	# calculate the final score

term.print("Number of correctly identified words: ");						# write information to terminal screen
term.print(iResultWord);
term.print("\n");
term.print("Number of correctly identified non-words: ");
term.print(iResultNonWord);
term.print("\n");
term.print("Total score: " + string(iResult));	

	
t_result.set_caption("Score: " + string(iResult));
t_result.redraw();
p_result.present();

templog = "";

templog.append("Number of correctly identified words: " + string(iResultWord)); 
templog.append("\n");
templog.append("Number of correctly identified non-words: " + string(iResultNonWord)); 
templog.append("\n");
templog.append("Total score: " + string(iResult)); 
templog.append("\n");
		
ofile1.open_append (logfile.subject() + "_" + "score.txt"); 
ofile1.print( templog );
ofile1.close();

WaitForAllButtonpress();